/**
 * $Id: ApplyImpl.java,v 1.11 2002/08/30 09:02:38 gchomat Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph call node interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph ;

public abstract class ApplyImpl
  extends CallImpl {

    // JE: LT has discarded the ref as class attribute, but I would prefer it...
    // String ref = null;
      
    public ApplyImpl (String n, String t, Process p, String r, int in, int out){
	super(n, t, p, in, out);
	// ref = r;
	if(r!=null)
	    iAttributes.setParameter("ref",r);
    
    }

  /** Propagates the nullity of all its output to all its input.
  * This is a basic implementation that does not take into account
  * the structure of the applied stuff and can be overloaded */
  public void retroNull( PortList out, PortList in) {
      nullified = true;
      for ( int i=1; nullified && i != out.length() ; i++){
	  if ( !(out.getPort(i).getChannel().nullifiedP()) )
	      nullified = false;
      } // end for
      for ( int i=1; i != in.length() ; i++) {
          in.getPort(i).getChannel().setVisited();
	  if ( nullified ) in.getPort(i).getChannel().nullify();
      } //end for
      visited = true;
  }
  public String getRef(){
      // return ref;
    return iAttributes.getStringParameter("ref");
  }

  public void setRef(String r){
      // ref = r;
      if(r!=null)
	  iAttributes.setParameter("ref",r);
  }

}
