/**
 * $Id: Namespace.java,v 1.1 2002/04/24 07:10:04 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * Transmorpher graph namespace interface
  *
  * @author Jerome.Euzenat@inrialpes.fr
  * @since jdk 1.3 / SAX 2.0
  */

package fr.fluxmedia.transmorpher.Graph.Rules ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;

public class Namespace implements Rule {

  public String name = null;
  public String uri = null;

  public Namespace(String n, String v){
    super();
    name = n;
    uri = v;
  }

  /** Prints the XML expression of the rule */
  public void generateXML(){
    System.out.println("    <namespace name=\""+name+"\" uri=\""+uri+"\"/>");
  }

  public void generateXSLTCode(ReadWrite file){
    file.Writeln(2,"xmlns:"+name+"=\""+uri+"\"");
  }

  /** Prints the XSLT code inside a ModTag template */
  public void generateInsideXSLTCode(ReadWrite file){}

  /** Prints the Java code for the execution of the rule */
  public void generateJavaCode(ReadWrite file){
    System.out.println("[Namespace]generateJavaCode : not yet implemented");
  }

}
