/**
 * $Id: FMParser.java,v 1.22 2002/07/05 10:30:04 gchomat Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
   Author  : Laurent Tardif
   Date    : 05 01 2001
   Content : Define a parser for XML Document

*/

package fr.fluxmedia.transmorpher.Parser ;


// Imported SAX Classes

import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXException ;
import org.xml.sax.SAXParseException;
import org.xml.sax.helpers.XMLFilterImpl;

//Imported JAVA Classes

import java.io.*;
import java.util.Stack ;

import fr.fluxmedia.transmorpher.Graph.Transmorpher ;


/**
   Author  : Laurent Tardif
   Date    : 05 01 2001
   Content : Define a parser for XML Document
   
*/
public class FMParser
    extends DefaultHandler {
    
    /** The XML Parser class */
    protected static String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
    
    /** XML Parser */
     protected javax.xml.parsers.SAXParser iParser = null;
    
    /** The current context of the parsing*/
    Stack iContext = null ;
    
    /** The output for a servlet  */
    PrintWriter output=null;

    /* the complete strucuture of th process transmorpher*/
    //TransmorpherGraph graph = null;
    
    /* the mode validating or not*/
    protected int debugMode = 0;

    /*------------------------------------------ CONSTRUCTOR -----------------------------*/
    
    /** The constructor, build the XML Parser but not parse the document */
    public FMParser(int debug_mode) {
  try {
      debugMode = debug_mode;
      javax.xml.parsers.SAXParserFactory iParserFactory = javax.xml.parsers.SAXParserFactory.newInstance();
      if( debug_mode > 0 ) iParserFactory.setValidating(true);
      else iParserFactory.setValidating(false);
      iParserFactory.setNamespaceAware(true);
      iParser = iParserFactory.newSAXParser();

  }  catch (javax.xml.parsers.ParserConfigurationException CNFE) {
      System.out.println("FMParser :Error [" + CNFE +"]");
  }  catch (org.xml.sax.SAXException SaxE) {
      System.out.println("FMParser :Error [" + SaxE +"]");
  }
    }

    /*------------------------------------------- END CONSTRUCTOR ------------------------*/
    
  /** Parse the document given in parameter */
  public Transmorpher Newparse(String uri) {
    try {
	iParser.parse(uri,this);
    } catch (SAXException SE) {
	System.err.println("[FMParser]Erreur SAX(" + SE+")");
	System.err.println("[FMParser]Erreur SAX(" + SE.getMessage()+")");
	System.err.println("[FMParser]Erreur SAX(" + SE.getException()+")");
	SE.printStackTrace();
    } catch (java.io.IOException IOE) {
	System.err.println("[FMParser]Erreur IO(" + IOE+")");
    }
    return new Transmorpher(debugMode);
  }
    
   
    public void warning(SAXParseException exception)
	throws SAXException
    {
	System.err.println("warning");
    }
    
    public void error(SAXParseException ex)
    {
	System.err.print("Error!! ");
	System.err.println(ex);
    }
    
    public void fatalError(SAXParseException ex) throws SAXException
    {
	System.err.print("Fatal Error!! ");
	System.err.println(ex);
    }
}
