/**
 * $Id: TReader.java,v 1.28 2002/09/20 06:54:20 triolet Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
 * This class provide a basic process which is
 * able to read an XML file
 *
 * @author Laurent.Tardif@inrialpes.fr
 * @since jdk 1.3 && SAX 2.0
 */


package fr.fluxmedia.transmorpher.TProcessFactory ;

// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;

// Imported Java classes

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.lang.Runnable ;

// Imported Transmorpher classes

import fr.fluxmedia.transmorpher.Utils.Parameters ;
import fr.fluxmedia.transmorpher.Utils.StringParameters;
import fr.fluxmedia.transmorpher.Utils.SystemResources;
import fr.fluxmedia.transmorpher.Files.ReadWrite;

public abstract class TReader extends TProcessBasic implements Runnable {
    
    //
    // Constants
    //

    /** Namespaces feature id (http://xml.org/sax/features/namespaces). */
    protected static final String NAMESPACES_FEATURE_ID = "http://xml.org/sax/features/namespaces";
    
    /** Namespaces feature id (http://xml.org/sax/features/namespaces). */
    protected static final String NAMESPACES_PREFIXES_FEATURE_ID = "http://xml.org/sax/features/namespace-prefixes";

    /** Validation feature id (http://xml.org/sax/features/validation). */
    protected static final String VALIDATION_FEATURE_ID = "http://xml.org/sax/features/validation";

    /** Schema validation feature id (http://apache.org/xml/features/validation/schema). */
    protected static final String SCHEMA_VALIDATION_FEATURE_ID = "http://apache.org/xml/features/validation/schema";

    // property ids

    /** Lexical handler property id (http://xml.org/sax/properties/lexical-handler). */
    protected static final String LEXICAL_HANDLER_PROPERTY_ID = "http://xml.org/sax/properties/lexical-handler";

    // default settings

    /** Default parser name. */
    //protected static final String DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";
  
    // default settings

    /** Default namespaces support (true). */
    protected static final boolean DEFAULT_NAMESPACES = true;

    /** Default namespaces support (true). */
    protected static final boolean DEFAULT_NAMESPACES_PREFIXES = true;

    /** Default validation support (false). */
    protected static final boolean DEFAULT_VALIDATION = false;
    
    /** Default Schema validation support (false). */
    protected static final boolean DEFAULT_SCHEMA_VALIDATION = false;

    /** The XMLReader */
    public XMLReader iReader = null;
    public boolean isThread = false ;
    public boolean isRunning = false ;
    public Thread myThread = null;
  
    //InputSource standardInput = null;
    
    public TReader (String[] pOut, Parameters pParam,StringParameters pStaticAttributes)
	throws SAXException, IOException   {
	super(new String[0],pOut,pParam);
	//if (isThread) myThread = new Thread(this);
    }
   
    /** Exec the process */
    public abstract void execProcess() throws IOException,SAXException;
    
     /** Exec the process inside a Loop*/
    public abstract void  execProcess(String fileName) throws IOException,SAXException;

    public void generatePort(){
	iListOut[0] = new XML_Port(nameOut[0],this,(XMLReader)iReader,0,XML_Port.OUT);
    }
    
    public void setThread(boolean useThread){
	    isThread=useThread;
	    if(myThread==null)
		    myThread = new Thread(this);
    }
    
    public abstract void run();
}
