/**
 * $Id: TSerializer.java,v 1.21 2002/09/24 06:23:11 triolet Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * This class offer a serializer mechanisme. A way to finish the transphormation process
  * bye writing XML output file
  *
  * @author laurent tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  */

package fr.fluxmedia.transmorpher.TProcessFactory ;

import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;

// Imported SAX classes

import org.xml.sax.ContentHandler;

import javax.xml.transform.OutputKeys;

public abstract class TSerializer extends TProcessBasic {
    
    public java.util.Properties Op = null;
    public Parameters param;
    /** the name of the file to write */
	public String fileName = null;
	
  public TSerializer (String[] pIn,Parameters pParam,StringParameters pStaticAttributes)
     {
	 super(pIn,new String[0],pParam);
	 param=pParam;
	 String method = (String)pParam.getParameter("method");
	 if ( method == null ) method = "xml";
	 if (method=="html") method ="xhtml";
	 // This is the Xalan specific action
	 // It is useful for having sensible default actions for text for instance
	 // For the property names, one should also use javax.xml.transform.OutputKeys.ENCODING
	 //Op = OutputProperties.getDefaultMethodProperties(method);
	 if ( Op == null ){
	     Op = new java.util.Properties();
	 }
	 Op.setProperty("method",method);
	 if ( pParam.getParameter("version") != null ) {
	     Op.setProperty("version",(String)pParam.getParameter("version"));
	 } else {
	     Op.setProperty("version","1.0");
	 }
	 if ( pParam.getParameter("encoding") != null ) {
	     Op.setProperty("encoding",(String)pParam.getParameter("encoding"));
	 } else {
	     Op.setProperty("encoding","ISO-8859-1");
	 }
	 if ( pParam.getParameter("omit-xml-declaration") != null ) {
	     Op.setProperty("omit-xml-declaration",(String)pParam.getParameter("omit-xml-declaration"));
	 } else {
	     Op.setProperty("omit-xml-declaration","no");
	 }
	 if ( pParam.getParameter("standalone") != null ) {
	     Op.setProperty("standalone",(String)pParam.getParameter("standalone"));
	 } else {
	     Op.setProperty("standalone","yes");
	 }
	 if ( pParam.getParameter("doctype-public") != null ) {
	     Op.setProperty("doctype-public",(String)pParam.getParameter("doctype-public"));
	 }
	 if ( pParam.getParameter("doctype-system") != null ) {
	     Op.setProperty("doctype-system",(String)pParam.getParameter("doctype-system"));
	 }
	 if ( pParam.getParameter("cdata-section-elements") != null ) {
	     Op.setProperty("cdata-section-elements",(String)pParam.getParameter("cdata-section-elements"));
	 }
	 if ( pParam.getParameter("indent") != null ) {
	     Op.setProperty("indent",(String)pParam.getParameter("indent"));
	 } else {
	     Op.setProperty("indent","no");
	 }
	 if ( pParam.getParameter("media-type") != null ) {
	     Op.setProperty("media-type",(String)pParam.getParameter("media-type"));
	 } else {
	     Op.setProperty("media-type","text/xml");
	 }
     }

     public void setOutputStream(){
	     super.bindParameters(getParameters());
		fileName=(String)getParameters().getParameter("file");
		getParameters().setParameter("file",param.getParameter("file"));
    }
     
     //public void reset(){}
     
     public void bindParameters(Parameters p){
	     super.bindParameters( p);
	     setOutputStream();
     }
     
    public void generatePort(ContentHandler c){
	String nameI= nameIn[0];
	nameFather=null;
	if(nameFather != null)
	    nameI = nameFather+"-"+nameI;
	try{
	    iListIn[0]=new XML_Port(nameI,this,c,0,XML_Port.IN);
	}
	catch(Exception e) {
	    System.out.println("[TSerializer] generatePort" +e);
	} //end try
    }
} //end class
