/**
 * $Id: broadcast.java,v 1.4 2002/10/16 08:11:11 triolet Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
  * this class define the dispatcher process.
  * dispatch one data flow to different process.
  *
  * @ author laurent tardif
  * @date 10 02 2001
  * @since jdk 1.2 SAX 2.0
  */

package fr.fluxmedia.transmorpher.stdlib ;

// Imported transmorpher classes
import fr.fluxmedia.transmorpher.TProcessFactory.*;
import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;
// Imported SAX classes

import org.xml.sax.ContentHandler;
import org.xml.sax.Attributes;
import org.xml.sax.Locator ;
import org.xml.sax.SAXException;

import java.util.Hashtable;

public final class broadcast extends TDispatcher {

    /** the constructor */
    public broadcast(String[] pIn, String[] pOut,Parameters pParam){
	super(pIn,pOut,pParam);
    }
        
    /** the start element method of content handler interface */
    public final void startElement(String ns,String localName,String name, Attributes atts) throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].startElement( ns, localName, name,  atts);
	}
    }
    
    /** the endElement method of content handler interface */
    public final void endElement(String ns,String localName,String name) throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].endElement( ns, localName, name);
	}
    }

    /** the setDocumentLocator method of content handler interface */
    public final void setDocumentLocator(Locator locator) {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].setDocumentLocator( locator);
	}
    }

    /** the startDocument method of content handler interface */
    public final void startDocument() throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].startDocument();
	}
    }

    /** the endDocument method of content handler interface */
    public final void endDocument() throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].endDocument();
	}
    }

    /** the skippedEntity method of content handler interface */
    public final void skippedEntity(java.lang.String name) throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].skippedEntity( name);
	}
    }

    /** the processingInstruction method of content handler interface */
    public final void processingInstruction(java.lang.String target, java.lang.String data) throws SAXException {
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].processingInstruction(target, data);
	}
    }

    /** the ignorableWhitespace method of content handler interface */
    public final void ignorableWhitespace(char[] ch, int start, int length) throws SAXException{
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].ignorableWhitespace( ch,  start,  length);
	}
    }

    /** the characters method of content handler interface */
    public final void characters(char[] ch, int start, int length) throws SAXException{
	for (int i=0; i<iNbOut; i++) {
		char[] tmp = null;
		tmp=new char[length + start];
		for (int j = start; j < length + start; j++) {
			tmp[j] = ch[j];
		}
	    contentHandlers[i].characters( ch,  start,  length);
	}
    }

    /** the startPrefixMapping method of content handler interface */
    public final void startPrefixMapping(java.lang.String prefix, java.lang.String uri) throws SAXException{
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].startPrefixMapping( prefix,uri);
	}
    }

    /** the endPrefixMapping method of content handler interface */
    public final void endPrefixMapping(java.lang.String prefix) throws SAXException{
	for (int i=0; i<iNbOut; i++) {
	    contentHandlers[i].endPrefixMapping( prefix);
	}
    }
    
} //end class
