/**
 * $Id: stdout.java,v 1.2 2002/09/12 14:58:06 triolet Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
/**
  * This class offer a serializer mechanisme. A way to finish the transphormation process
  * bye writing XML output file
  *
  * @author laurent tardif@inrialpes.fr
  * @date 10 02 2001
  * @since jdk 1.3 && SAX 2.0
  */

package fr.fluxmedia.transmorpher.stdlib ;

import fr.fluxmedia.transmorpher.TProcessFactory.*;
import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;

// Imported SAX classes

import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;

// Imported Serializer classes
// JE: why this depends on Xalan?

/* import org.apache.xalan.serialize.Serializer;
import org.apache.xalan.serialize.SerializerFactory;
import org.apache.xalan.templates.OutputProperties; */

// Imported java.io classes
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.File;
import java.io.IOException;

import java.util.Hashtable;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.stream.StreamResult;

public final class stdout extends TSerializer {
    
  /** the serializer */
  //Serializer serializer = null;
  
    TransformerHandler handler;
    
    SAXTransformerFactory tfactory = null;
    
    Parameters param;
    
  public stdout (String[] pIn,Parameters pParam,StringParameters pStaticAttributes)
    throws SAXException, IOException {
      super(pIn,pParam, pStaticAttributes);
      param=pParam;
      try{
			handler = getTransformerFactory().newTransformerHandler();
	}
	catch (Exception e){
		e.printStackTrace();
	}
    
      //java.util.Properties Op = OutputProperties.getDefaultMethodProperties("xml");
      //serializer = SerializerFactory.getSerializer(Op);
      //serializer.setOutputStream(System.out);
      setOutputStream();
      //generatePort();
  }
  
  protected SAXTransformerFactory getTransformerFactory(){
		if(tfactory == null){
			tfactory = (SAXTransformerFactory) TransformerFactory.newInstance();
		}
		return tfactory;
	}
    public void setOutputStream() {
			try {
				handler.getTransformer().setOutputProperties(Op);
				handler.setResult(new StreamResult(System.out));
			}
			catch (Exception e){
				System.out.println("[writefile]erreur : " + e);
				e.printStackTrace();
			}
		}
    public void generatePort(){
   	    super.generatePort((ContentHandler)handler);

	/* try {
	    super.generatePort((ContentHandler)serializer.asContentHandler());
	} catch(IOException IOE) {
	    System.out.println("[stdout]erreur : " + IOE);
	    IOE.printStackTrace();
	} //end try */
    }
    
}    //end class
