/**
 * $Id: writefile.java,v 1.8 2002/10/16 07:32:17 jerome Exp $
 *
 * Transmorpher
 *
 * Copyright (C) 2001-2002 Fluxmedia and INRIA Rhne-Alpes.
 *
 * http://www.fluxmedia.fr - http://transmorpher.inrialpes.fr
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

package fr.fluxmedia.transmorpher.stdlib;

import fr.fluxmedia.transmorpher.Files.ReadWrite;
import fr.fluxmedia.transmorpher.TProcessFactory.*;
import fr.fluxmedia.transmorpher.Utils.Parameters;
import fr.fluxmedia.transmorpher.Utils.StringParameters;
// Imported java.io classes
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.BufferedOutputStream;
import java.io.StringWriter;
import java.util.Properties;
// Imported SAX classes
import org.xml.sax.SAXException;
import org.xml.sax.ContentHandler;

import javax.xml.transform.TransformerFactory;
import javax.xml.transform.sax.SAXTransformerFactory;
import javax.xml.transform.sax.TransformerHandler;
import javax.xml.transform.stream.StreamResult;



/**
 * This class offer a serializer mechanisme. A way to finish the transphormation process
 * by writing XML output file
 *
 *@author    laurent tardif@inrialpes.fr
 *@since     jdk 1.3 && SAX 2.0
 *@date      10 02 2001
 */
public final class writefile extends TSerializer {
	
	TransformerHandler handler;
	
	static final int DEFAULT_BUFFER_SIZE = 8192;
	
	int outputBufferSize = DEFAULT_BUFFER_SIZE;
	
	SAXTransformerFactory tfactory = null;
	
	/**
	 *Constructor for the writefile object
	 *
	 *@param  pIn                in ports of this object
	 *@param  pParam             Description of the Parameter
	 *@param  pStaticAttributes  Description of the Parameter
	 *@exception  SAXException   Description of the Exception
	 *@exception  IOException    Description of the Exception
	 */
	public writefile(String[] pIn, Parameters pParam, StringParameters pStaticAttributes)
			 throws SAXException, IOException {
		super(pIn, pParam, pStaticAttributes);
		//param = pParam;
		try{
			handler = getTransformerFactory().newTransformerHandler();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}

	protected SAXTransformerFactory getTransformerFactory(){
		if(tfactory == null){
			tfactory = (SAXTransformerFactory) TransformerFactory.newInstance();
		}
		return tfactory;
	}
	
	/**
	 *  Sets the ouput file of this serializer
	 *  path is needed when this serializer is used inside a loop.
	 *
	 *@param  name  The file name to write in
	 */
	public void setOutputStream() {
		super.setOutputStream();
		if (fileName.lastIndexOf('$')==-1){
			try {
				FileOutputStream FOS = null;
				FOS = new FileOutputStream(new File(fileName));
				BufferedOutputStream streamBuffer=null;
				streamBuffer = new BufferedOutputStream(FOS,outputBufferSize);
				handler.getTransformer().setOutputProperties(Op);
				handler.setResult(new StreamResult(streamBuffer));
			} catch (IOException IOE) {
				System.out.println("[writefile]erreur : " + IOE);
				System.out.println("[writefile]erreur : f=" + fileName);
				IOE.printStackTrace();
			}//end try
			catch (Exception e){
				System.out.println("[writefile]erreur : " + e);
				e.printStackTrace();
			}
		}
	}
	  
	public void reset(){
		try{
			handler=null;
			handler = getTransformerFactory().newTransformerHandler();
		}
		catch (Exception e){
			e.printStackTrace();
		}
	}
	
	/**  Generates ports for this component */
	public void generatePort() {
			super.generatePort((ContentHandler) handler);
	}
}

