package fr.fluxmedia.transmorpher.Graph;

import junit.framework.TestCase;
// JUnitDoclet begin import
import java.io.File;
// JUnitDoclet end import

/**
* Generated by JUnitDoclet, a tool provided by
* ObjectFab GmbH under LGPL.
* Please see www.junitdoclet.org, www.gnu.org
* and www.objectfab.de for informations about
* the tool, the licence and the the authors.
*/


public class TransmorpherTest
// JUnitDoclet begin extends_implements
extends TestCase
// JUnitDoclet end extends_implements
{
  // JUnitDoclet begin class
  fr.fluxmedia.transmorpher.Graph.Transmorpher transmorpher = null;
  fr.fluxmedia.transmorpher.Graph.Transmorpher t1 = null;
  fr.fluxmedia.transmorpher.Graph.Transmorpher t2 = null;
	/*
  public final MainProcess getMain(){
  public final void setMain(MainProcess p){
  public LinearIndexedStruct getTransformations(){
  public final Transformation getTransformation(String name){
  public final void addTransformation(String name, Transformation t){
  public final void removeTransformation( Transformation trans ) {
  public final void retroNull(){
  public final void generateXML(){
  public final void generateExec(String reloc)
    public final void generateJavaCode(String reloc) {

	 */
  // JUnitDoclet end class
  
  public TransmorpherTest(String name) {
    // JUnitDoclet begin method TransmorpherTest()
    super(name);
    // JUnitDoclet end method TransmorpherTest()
  }
  
  public void setUp() throws Exception {
    // JUnitDoclet begin method setUp()
    super.setUp();
    transmorpher = new fr.fluxmedia.transmorpher.Graph.Transmorpher(0);
    t1 = new Transmorpher( "testTrans", "1.0", 1, false);
    t2 = new Transmorpher( 2 );
    // JUnitDoclet end method setUp()
  }
  
  public void tearDown() throws Exception {
    // JUnitDoclet begin method tearDown()
    transmorpher = null;
    t1 = null;
    t2 = null;
    super.tearDown();
    // JUnitDoclet end method tearDown()
  }
  
  public void testSetGetName() throws Exception {
    // JUnitDoclet begin method testSetGetName()
    java.lang.String[] tests = {null, "", " ", "a", "A", "", "", "0123456789", "012345678901234567890", "\n"};
    
    for (int i = 0; i < tests.length; i++) {
      transmorpher.setName(tests[i]);
      assertEquals(tests[i], transmorpher.getName());
    }
    assertTrue(t1.getName().equals("testTrans"));
    t2.setName( "testTrans" );
    assertTrue( t2.getName().equals("testTrans") );
    // JUnitDoclet end method testSetGetName()
  }
  
  public void testSetGetDebug() throws Exception {
    // JUnitDoclet begin method testSetGetDebug()
    int[] tests = {Integer.MIN_VALUE, -1, 0, 1, Integer.MAX_VALUE};
    
    for (int i = 0; i < tests.length; i++) {
      transmorpher.setDebug(tests[i]);
      assertEquals(tests[i], transmorpher.getDebug());
    }
    assertEquals(t1.getDebug(),1);
    assertEquals(t2.getDebug(),2);
    t2.setDebug( 1 );
    assertEquals( t2.getDebug(), 1 );
    // JUnitDoclet end method testSetGetDebug()
  }
  
  public void testIsThread() throws Exception {
    // JUnitDoclet begin method testIsThread()
      assertTrue( !t1.isThread() );
      assertTrue( !t2.isThread() );
    // JUnitDoclet end method testIsThread()
  }
  
  public void testUseThread() throws Exception {
    // JUnitDoclet begin method testUseThread()
    // JUnitDoclet end method testUseThread()
  }
  
  public void testSetGetFile() throws Exception {
    // JUnitDoclet begin method testSetGetFile()
    java.io.File[] tests = {null, new java.io.File("aa")};
    
    for (int i = 0; i < tests.length; i++) {
      transmorpher.setFile(tests[i]);
      assertEquals(tests[i], transmorpher.getFile());
    }
    assertTrue( t1.getFile() != null );
    assertTrue( t1.getFile().getName().equals("testTrans.xml") );
    t2.setFile( new File( "testTrans.xml" ) );
    assertTrue( t2.getFile() != null );
    assertTrue( t2.getFile().getName().equals("testTrans.xml") );
    // JUnitDoclet end method testSetGetFile()
  }
  
  public void testSetGetVersion() throws Exception {
    // JUnitDoclet begin method testSetGetVersion()
    java.lang.String[] tests = {null, "", " ", "a", "A", "", "", "0123456789", "012345678901234567890", "\n"};
    
    for (int i = 0; i < tests.length; i++) {
      transmorpher.setVersion(tests[i]);
      assertEquals(tests[i], transmorpher.getVersion());
    }
    assertTrue( t1.getVersion().equals("1.0") );
    // Might not be ideal
    assertTrue( t2.getVersion() == null );
    t2.setVersion( "0.1" );
    // This one is an error case: it should not be possible to set
    // a version other than the current one.
    assertTrue( t2.getVersion().equals("0.1") );
    // JUnitDoclet end method testSetGetVersion()
  }
  
  public void testOptimizedP() throws Exception {
    // JUnitDoclet begin method testOptimizedP()
    assertTrue( !t1.optimizedP() );
    assertTrue( !t2.optimizedP() );
    // JUnitDoclet end method testOptimizedP()
  }
  
  public void testSetOptimized() throws Exception {
    // JUnitDoclet begin method testSetOptimized()
    t2.setOptimized( true );
    assertTrue( t2.optimizedP() );
    // JUnitDoclet end method testSetOptimized()
  }
  
  public void testGetTransformations() throws Exception {
    // JUnitDoclet begin method testGetTransformations()
    // JUnitDoclet end method testGetTransformations()
  }
  
  public void testGetTransformation() throws Exception {
    // JUnitDoclet begin method testGetTransformation()
    // JUnitDoclet end method testGetTransformation()
  }
  
  public void testAddTransformation() throws Exception {
    // JUnitDoclet begin method testAddTransformation()
    // JUnitDoclet end method testAddTransformation()
  }
  
  public void testRemoveTransformation() throws Exception {
    // JUnitDoclet begin method testRemoveTransformation()
    // JUnitDoclet end method testRemoveTransformation()
  }
  
  public void testGetExtern() throws Exception {
    // JUnitDoclet begin method testGetExtern()
      assertTrue( t2.getExtern("bla") == null );
      t2.addExtern( "bla", "dummy.class.bla", "generator", false );
      // This interface is too light
      assertTrue( t2.getExtern("bla") != null );
      assertTrue( t2.getExtern("bla").equals("dummy.class.bla") );
      t2.removeExtern("bla");
      assertTrue( t2.getExtern("bla") == null );
    // JUnitDoclet end method testGetExtern()
  }
  
  public void testAddExtern() throws Exception {
    // JUnitDoclet begin method testAddExtern()
    // JUnitDoclet end method testAddExtern()
  }
  
  public void testRemoveExtern() throws Exception {
    // JUnitDoclet begin method testRemoveExtern()
    // JUnitDoclet end method testRemoveExtern()
  }
  
  public void testGetDefexterns() throws Exception {
    // JUnitDoclet begin method testGetDefexterns()
      assertTrue( t2.getDefexterns() != null );
    // JUnitDoclet end method testGetDefexterns()
  }
  
  public void testAddImport() throws Exception {
    // JUnitDoclet begin method testAddImport()
      assertTrue( t2.getImports() != null );
      assertTrue( t2.getIncludes() != null );
      assertEquals( t1.getImports().size(), 0 );
      { String name = "";
	  t1.addImport( name );
	  assertTrue( t1.getImports().contains((Object)name) );
	  assertEquals( t1.getIncludes().size(), 0 );
	  t1.addInclude( name );
	  assertTrue( t1.getIncludes().contains((Object)name) );}
    // JUnitDoclet end method testAddImport()
  }
  
  public void testGetImports() throws Exception {
    // JUnitDoclet begin method testGetImports()
    // JUnitDoclet end method testGetImports()
  }
  
  public void testAddInclude() throws Exception {
    // JUnitDoclet begin method testAddInclude()
    // JUnitDoclet end method testAddInclude()
  }
  
  public void testGetIncludes() throws Exception {
    // JUnitDoclet begin method testGetIncludes()
    // JUnitDoclet end method testGetIncludes()
  }
  
  public void testSetGetMain() throws Exception {
    // JUnitDoclet begin method testSetGetMain()
      /*
    fr.fluxmedia.transmorpher.Graph.MainProcess[] tests = {null, new fr.fluxmedia.transmorpher.Graph.MainProcess()};
    
    for (int i = 0; i < tests.length; i++) {
      transmorpher.setMain(tests[i]);
      assertEquals(tests[i], transmorpher.getMain());
    }
      */
    // JUnitDoclet end method testSetGetMain()
  }
  
  public void testRetroNull() throws Exception {
    // JUnitDoclet begin method testRetroNull()
    // JUnitDoclet end method testRetroNull()
  }
  
  public void testGenerateXML() throws Exception {
    // JUnitDoclet begin method testGenerateXML()
    // JUnitDoclet end method testGenerateXML()
  }
  
  public void testGenerateExec() throws Exception {
    // JUnitDoclet begin method testGenerateExec()
    // JUnitDoclet end method testGenerateExec()
  }
  
  public void testGenerateJavaCode() throws Exception {
    // JUnitDoclet begin method testGenerateJavaCode()
    // JUnitDoclet end method testGenerateJavaCode()
  }
  
  public void testExec() throws Exception {
    // JUnitDoclet begin method testExec()
    // JUnitDoclet end method testExec()
  }
  
  
  
  /**
  * JUnitDoclet moves marker to this method, if there is not match
  * for them in the regenerated code and if the marker is not empty.
  * This way, no test gets lost when regenerating after renaming.
  * Method testVault is supposed to be empty.
  */
  public void testVault() throws Exception {
    // JUnitDoclet begin method testVault()
    // JUnitDoclet end method testVault()
  }
  
}
